Backport187 - Bug #2244

object allocation bug with ActiveRecord
10/21/2009 06:47 PM - ASUS1983 (Henning Méller)

Status: Rejected
Priority: Normal
Assignee: naruse (Yui NARUSE)

Target version:

ruby -v: 1.8.7

Description
=begin

/usr/lib/ruby/gems/1.8/gems/activerecord-2.3.4/lib/active_record/connection_adapters/abstract/query_cache.rb:85: [BUG] object

allocation during garbage collection phase
ruby 1.8.7 (2008-06-20 patchlevel 22) [x86_64-linux]
=end

History

#1 - 10/21/2009 07:17 PM - naruse (Yui NARUSE)
- Subject changed from Bug to object allocation bug with ActiveRecord
- Status changed from Open to Feedback

- Priority changed from 5 to Normal

=begin

It seems to be caused by Third Party's extension library.
Can you show us more details of this?

=end

#2 - 10/21/2009 08:31 PM - murphy (Kornelius Kalnbach)

=begin
The affected code is the line

result.collect { [row| row.dup }
in this method:

module ActiveRecord

module ConnectionAdapters # :nodoc:
module QueryCache

class << self

def included(base)

base.class_eval do

alias_method_chain :columns, :query_cache
alias_method_chain :select_all, :query_cache

end
dirties_query_cache base, :insert, :update, :delete
end
def dirties_query_cache (base, *method_names)
method_names.each do |method_name|
base.class_eval <<-end_code, _ FILE_ , _ LINE_
def #{method_name}_with_query_dirty (*args)
clear_query_cache if @query_cache_enabled
#{method_name}_without_query_dirty (*args)
end
alias_method_chain :#{method_name}, :query_dirty
end_code
end
end
end

attr_reader :query_cache, :query_cache_enabled
def update_with_query_dirty (*args)
clear_query_cache if @query_cache_enabled
update_without_query_dirty (*args)

end

alias_method_chain

:update, :query_dirty
# Enable the query cache within the block.
def cache

old, @query_cache_enabled = Qquery_cache_enabled, true

@query_cache ||= {}
yield
ensure
clear_qguery_cache
Qquery_cache_enabled = old
end

# Disable the query cache within the block.
def uncached

old, @query_cache_enabled = (@query_cache_enabled,

yield
ensure
@Qquery_cache_enabled = old

false

end

# Clears the query cache.

#

# One reason you may wish to call this method explicitly is between queries

# that ask the database to randomize results. Otherwise the cache would see

# the same SQL query and repeatedly return the same result each time, silently
# undermining the randomness you were expecting.

def clear_query_cache
@Qquery_cache.clear if @gquery_cache
end

def select_all_with_query_cache (*args)
if Qquery_cache_enabled

cache_sqgl (args.first) { select_all_without_query_cache (*args) }
else

select_all_without_query_cache (*args)
end

end

def columns_with_query_cache (*args)
if Qquery_cache_enabled

@Qquery_cache["SHOW FIELDS FROM #{args.first}"]

else
columns_without_query_cache (*args)
end
end

private
def cache_sqgl (sqgl)
result =
if @query_cache.has_key? (sql)
log_info(sqgl, "CACHE", 0.0)
@Qquery_cache[sqgl]

else
Q@query_cache[sgl] = yield
end
if Array === result
result.collect { |row| row.dup }
else
result.duplicable? ? result.dup : result
end
rescue TypeError
result
end
end
end
end
=end

#3 - 10/21/2009 09:27 PM - ASUS1983 (Henning Mdller)

=begin
How we can fix this or use another ext. libary?
=end
| = columns_without_query_cache (*args)
#4 - 10/21/2009 10:48 PM - naruse (Yui NARUSE)

=begin
What is this 'row'?

| think, this 'row' is SQLite or MySQL or PostgreSQL or some DB object.

And its bug arround dup method causes this behavior.
So what is your DB adaptor?

OR show me value of $".
=end

#5 - 10/22/2009 02:55 AM - drbrain (Eric Hodel)
- Assignee changed from drbrain (Eric Hodel) to naruse (Yui NARUSE)

=begin

=end

#6 - 12/14/2009 12:09 PM - naruse (Yui NARUSE)
- Status changed from Feedback to Rejected

=begin
This is third party's issue
=end
